## mingw-w64-sqlite-orm-1.8.2-1.src.tar.zst

=== CMakeLists.txt ===
# note: the minimum required version needs to go hand in hand with appveyor builds,
# which is CMake 3.16 for the Visual Studio 2017 build worker image
cmake_minimum_required (VERSION 3.16)

# PACKAGE_VERSION is used by cpack scripts currently
# Both sqlite_orm_VERSION and PACKAGE_VERSION should be the same for now

set(sqlite_orm_VERSION "1.8.0")
set(PACKAGE_VERSION ${sqlite_orm_VERSION})

project("sqlite_orm" VERSION ${PACKAGE_VERSION})

# Handling C++ standard version to use
option(SQLITE_ORM_ENABLE_CXX_20 "Enable C++ 20" OFF)
option(SQLITE_ORM_ENABLE_CXX_17 "Enable C++ 17" OFF)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
if(SQLITE_ORM_ENABLE_CXX_20)
    set(CMAKE_CXX_STANDARD 20)
    message(STATUS "SQLITE_ORM: Build with C++20 features")
elseif(SQLITE_ORM_ENABLE_CXX_17)
    set(CMAKE_CXX_STANDARD 17)
    message(STATUS "SQLITE_ORM: Build with C++17 features")
else()
    # fallback to C++14 if there is no special instruction
    set(CMAKE_CXX_STANDARD 14)
    message(STATUS "SQLITE_ORM: Build with C++14 features")
endif()
set(CMAKE_CXX_EXTENSIONS OFF)


set(CMAKE_VERBOSE_MAKEFILE ON)

message(STATUS "Configuring ${PROJECT_NAME} ${sqlite_orm_VERSION}")

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

include(CTest)

### Dependencies
add_subdirectory(dependencies)

### Main Build Targets
set(SqliteOrm_INCLUDE "${CMAKE_CURRENT_SOURCE_DIR}/include")
add_library(sqlite_orm INTERFACE)
add_library(sqlite_orm::sqlite_orm ALIAS sqlite_orm)

find_package(SQLite3 REQUIRED)
target_link_libraries(sqlite_orm INTERFACE SQLite::SQLite3)

target_sources(sqlite_orm INTERFACE $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include/sqlite_orm/sqlite_orm.h>)

target_include_directories(sqlite_orm INTERFACE $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>)

include(ucm)

if (MSVC)
    string(REGEX REPLACE "/RTC(su|[1su])" "" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")    
    string(REGEX REPLACE "/RTC(su|[1su])" "" CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG}")    
    string(REGEX REPLACE "/RTC(su|[1su])" "" CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE}")    
    add_compile_options(/EHsc)
    if (MSVC_VERSION GREATER_EQUAL 1914)
        add_compile_options(/Zc:__cplusplus)
    endif()
    if (MSVC_VERSION GREATER_EQUAL 1910)
        # VC 2017 issues a deprecation warning for `strncpy`
        add_compile_definitions(_CRT_SECURE_NO_WARNINGS)
    endif()
    add_compile_options(/MP) # multi-processor compilation
    if (CMAKE_CXX_STANDARD GREATER 14)
        add_compile_definitions(_SILENCE_CXX17_CODECVT_HEADER_DEPRECATION_WARNING)
    endif()

    if ("${CMAKE_GENERATOR}" MATCHES "(Win64|x64)")
        message(STATUS "Add /bigobj flag to compiler")
        add_compile_options(/bigobj)
    endif()
endif()

ucm_print_flags()
message(STATUS "CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")

# Tests
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME AND BUILD_TESTING)
    add_subdirectory(tests)
endif()

option(BUILD_EXAMPLES "Build code examples" OFF)
if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME AND BUILD_EXAMPLES)
    add_subdirectory(examples)
endif()

### Packaging
add_subdirectory(packaging)

=== examples/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.16)

# note: find_package(SQLite3 REQUIRED) already done in top-level CMakeLists

file(GLOB files "*.cpp")
foreach(file ${files})
    get_filename_component(file_basename ${file} NAME_WE)
    add_executable(${file_basename} ${file})
    # note: sqlite3 already linked in top-level CMakeLists
    target_link_libraries(${file_basename} PRIVATE sqlite_orm)
endforeach()

=== tests/CMakeLists.txt ===
cmake_minimum_required (VERSION 3.16)

# note: find_package(SQLite3 REQUIRED) already done in top-level CMakeLists
FetchContent_MakeAvailable(Catch2)

option(SQLITE_ORM_OMITS_CODECVT "Omits codec testing" OFF)

add_executable(unit_tests
    static_tests/functional/static_if_tests.cpp
    static_tests/functional/mpl.cpp
    static_tests/functional/same_or_void.cpp
    static_tests/functional/tuple_conc.cpp
    static_tests/functional/tuple_filter.cpp
    static_tests/functional/tuple_traits.cpp
    static_tests/functional/tuple_transform.cpp
    static_tests/is_printable.cpp
    static_tests/is_bindable.cpp
    static_tests/iterator_t.cpp
    static_tests/arithmetic_operators_result_type.cpp
    static_tests/node_tuple.cpp
    static_tests/bindable_filter.cpp
    static_tests/member_traits_tests.cpp
    static_tests/select_return_type.cpp
    static_tests/column.cpp
    static_tests/foreign_key.cpp
    static_tests/function_static_tests.cpp
    static_tests/aggregate_function_return_types.cpp
    static_tests/core_function_return_types.cpp
    static_tests/column_result_t.cpp
    static_tests/alias.cpp
    static_tests/is_primary_key_insertable.cpp
    static_tests/is_column_with_insertable_primary_key.cpp
    static_tests/operators_adl.cpp
    tuple_iteration.cpp
    sync_schema_tests.cpp
    tests.cpp
    tests2.cpp
    tests3.cpp
    tests4.cpp
    tests5.cpp
    column_tests.cpp
    private_getters_tests.cpp
    pragma_tests.cpp
    explicit_columns.cpp
    built_in_functions_tests/core_functions_tests.cpp
    built_in_functions_tests/datetime_function_tests.cpp
    built_in_functions_tests/math_functions.cpp
    index_tests.cpp
    constraints/composite_key.cpp
    operators/arithmetic_operators.cpp
    operators/like.cpp
    operators/glob.cpp
    operators/in.cpp
    operators/cast.cpp
    operators/is_null.cpp
    operators/not_operator.cpp
    operators/bitwise.cpp
    operators/binary_operators.cpp
    prepared_statement_tests/select.cpp
    prepared_statement_tests/get_all.cpp
    prepared_statement_tests/get_all_pointer.cpp
    prepared_statement_tests/get_all_optional.cpp
    prepared_statement_tests/update_all.cpp
    prepared_statement_tests/remove_all.cpp
    prepared_statement_tests/get.cpp
    prepared_statement_tests/get_pointer.cpp
    prepared_statement_tests/get_optional.cpp
    prepared_statement_tests/update.cpp
    prepared_statement_tests/remove.cpp
    prepared_statement_tests/insert.cpp
    prepared_statement_tests/replace.cpp
    prepared_statement_tests/insert_range.cpp
    prepared_statement_tests/replace_range.cpp
    prepared_statement_tests/insert_explicit.cpp
    prepared_statement_tests/column_names.cpp
    pragma_tests.cpp
    simple_query.cpp
    constraints/default.cpp
    constraints/unique.cpp
    constraints/foreign_key.cpp
    constraints/check.cpp
    table_tests.cpp
    statement_serializer_tests/column_constraints/generated.cpp
    statement_serializer_tests/column_constraints/default.cpp
    statement_serializer_tests/column_constraints/primary_key.cpp
    statement_serializer_tests/column_constraints/autoincrement.cpp
    statement_serializer_tests/column_constraints/unique.cpp
    statement_serializer_tests/column_constraints/check.cpp
    statement_serializer_tests/bindables.cpp
    statement_serializer_tests/ast/upsert_clause.cpp
    statement_serializer_tests/ast/excluded.cpp
    statement_serializer_tests/ast/set.cpp
    statement_serializer_tests/arithmetic_operators.cpp
    statement_serializer_tests/base_types.cpp
    statement_serializer_tests/collate.cpp
    statement_serializer_tests/comparison_operators.cpp
    statement_serializer_tests/core_functions.cpp
    statement_serializer_tests/rowid.cpp
    statement_serializer_tests/column_names.cpp
    statement_serializer_tests/foreign_key.cpp
    statement_serializer_tests/schema/index.cpp
    statement_serializer_tests/schema/trigger.cpp
    statement_serializer_tests/schema/new_old.cpp
    statement_serializer_tests/schema/raise.cpp
    statement_serializer_tests/indexed_column.cpp
    statement_serializer_tests/logical_operators.cpp
    statement_serializer_tests/statements/select.cpp
    statement_serializer_tests/select_constraints.cpp
    statement_serializer_tests/conditions.cpp
    statement_serializer_tests/statements/insert_replace.cpp
    statement_serializer_tests/statements/update.cpp
    statement_serializer_tests/statements/remove.cpp
    statement_serializer_tests/statements/update_all.cpp
    statement_serializer_tests/aggregate_functions.cpp
    statement_serializer_tests/alias_extractor.cpp
    storage_tests.cpp
    storage_non_crud_tests.cpp
    unique_cases/get_all_with_two_tables.cpp
    unique_cases/prepare_get_all_with_case.cpp
    unique_cases/index_named_table_with_fk.cpp
    unique_cases/issue525.cpp
    unique_cases/delete_with_two_fields.cpp
    unique_cases/join_iterator_ctor_compilation_error.cpp
    unique_cases/issue86.cpp
    unique_cases/issue937.cpp
    unique_cases/issue663.cpp
    get_all_custom_containers.cpp
    select_constraints_tests.cpp
    backup_tests.cpp
    transaction_tests.cpp
    json.cpp
    row_id.cpp
    trigger_tests.cpp
    ast_iterator_tests.cpp
    table_name_collector.cpp
    pointer_passing_interface.cpp
)

if(SQLITE_ORM_OMITS_CODECVT)
    message(STATUS "SQLITE_ORM_OMITS_CODECVT is enabled")
    target_compile_definitions(unit_tests PRIVATE SQLITE_ORM_OMITS_CODECVT=1)
endif()

if (MSVC)
    target_compile_options(unit_tests PUBLIC
        # multi-processor compilation
        /MP)
    if (MSVC_VERSION LESS_EQUAL 1900)
        target_compile_options(unit_tests PUBLIC
            # C4503: decorated name length exceeded
            /wd4503
            # C4800: forcing value to bool (performance warning)
            /wd4800)
    else()
        target_compile_options(unit_tests PUBLIC
            # warning-level 4
            /W4
            # C4127: conditional expression is constant
            /wd4127
            # C4456: declaration of 'symbol' hides previous local declaration
            /wd4456
            # C4458: declaration of 'symbol' hides class member
            /wd4458)
    endif()
endif()

target_precompile_headers(unit_tests PRIVATE
    <sqlite_orm/sqlite_orm.h>
    <catch2/catch_all.hpp>)

# note: sqlite3 already linked in top-level CMakeLists
target_link_libraries(unit_tests PRIVATE sqlite_orm Catch2::Catch2WithMain)

add_test(NAME "All_in_one_unit_test"
    COMMAND unit_tests
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})

=== PKGBUILD ===
# Maintainer: Konstantin Podsvirov <konstantin@podsvirov.pro>

_realname=sqlite-orm
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.8.2
pkgrel=1
pkgdesc="SQLite ORM light header only library for modern C++ (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clangarm64' 'clang32')
url="https://github.com/fnc12/sqlite_orm"
license=('AGPL3')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
depends=("${MINGW_PACKAGE_PREFIX}-sqlite3")
source=("${_realname/-/_}-${pkgver}.tar.gz::${url}/archive/v${pkgver}.tar.gz")
sha256sums=('56e0c7729800637a8061658d0fdad4424d2cdde77b063d23cc1b76aa20339072')

build() {
  [[ -d "${srcdir}/build-${MSYSTEM}" ]] && rm -rf "${srcdir}/build-${MSYSTEM}"
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -GNinja \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DCMAKE_BUILD_TYPE=Release \
    -DBUILD_TESTING=OFF \
    -DBUILD_EXAMPLES=OFF \
    ../${_realname/-/_}-${pkgver}

  ${MINGW_PREFIX}/bin/cmake.exe --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake.exe --install .

  install -Dm644 "${srcdir}/${_realname/-/_}-${pkgver}/README.md" "${pkgdir}${MINGW_PREFIX}/share/doc/${_realname}/README.md"
  install -Dm644 "${srcdir}/${_realname/-/_}-${pkgver}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}

# vim:set ts=2 sw=2 et:
